import _extends from "@babel/runtime/helpers/esm/extends";
import PropTypes from 'prop-types';
import cx from 'classnames';
import ActionableTagContainer from './Container';
import { LINK_TYPES } from '../constants';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var RIGHT_ICON_PLACEMENT = 'right';
var LEFT_ICON_PLACEMENT = 'left';

var getClassNames = function getClassNames(_ref) {
  var className = _ref.className,
      disabled = _ref.disabled;
  return cx('sui-AtomTag-actionable', disabled && 'sui-AtomTag--disabled', className);
};

var getLinkTypesString = function getLinkTypesString(types) {
  return types && types.join(' ');
};

var ActionableTag = function ActionableTag(_ref2) {
  var icon = _ref2.icon,
      href = _ref2.href,
      iconPlacement = _ref2.iconPlacement,
      label = _ref2.label,
      _ref2$onClick = _ref2.onClick,
      _onClick = _ref2$onClick === void 0 ? function () {} : _ref2$onClick,
      target = _ref2.target,
      rel = _ref2.rel,
      linkFactory = _ref2.linkFactory,
      className = _ref2.className,
      disabled = _ref2.disabled,
      _ref2$value = _ref2.value,
      value = _ref2$value === void 0 ? null : _ref2$value;

  return /*#__PURE__*/_jsxs(ActionableTagContainer, {
    className: getClassNames({
      className: className,
      disabled: disabled
    }),
    Link: linkFactory,
    onClick: function onClick(ev) {
      if (disabled) {
        return;
      }

      _onClick(ev, {
        value: value,
        label: label
      });
    },
    href: href,
    target: target,
    rel: rel,
    disabled: disabled,
    children: [icon && iconPlacement === LEFT_ICON_PLACEMENT && /*#__PURE__*/_jsx("span", {
      className: "sui-AtomTag-icon",
      children: icon
    }), /*#__PURE__*/_jsx("span", {
      className: "sui-AtomTag-label",
      title: label,
      children: label
    }), icon && iconPlacement === RIGHT_ICON_PLACEMENT && /*#__PURE__*/_jsx("span", {
      className: "sui-AtomTag-secondary-icon",
      children: icon
    })]
  });
};

ActionableTag.defaultProps = {
  // eslint-disable-next-line react/prop-types
  linkFactory: function linkFactory(_temp) {
    var _ref3 = _temp === void 0 ? {} : _temp,
        href = _ref3.href,
        target = _ref3.target,
        rel = _ref3.rel,
        className = _ref3.className,
        role = _ref3.role,
        children = _ref3.children;

    var optionalProps = _extends({}, rel && {
      rel: getLinkTypesString(rel)
    });

    return /*#__PURE__*/_jsx("a", _extends({
      href: href,
      target: target,
      className: className,
      role: role
    }, optionalProps, {
      children: children
    }));
  }
};
export default ActionableTag;